package work.xuye.common.store;

import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author xuye
 * @since 2023/3/27 11:02
 **/
@Component
public class LocalMemoryNsKVMapStore implements NsKVMapStore {

    private final static String GLH_V2 = "glh_v2_rss";

    /**
     * key: 命名空间，默认以任务名命名
     * value: key：key
     * value：value：value
     */
    private Map<String, Map<String, Object>> store = null;


    @PostConstruct
    public void init() {
        if (store != null) {
            store.clear();
        } else {
            store = new ConcurrentHashMap<>();
        }
        store.put(GLH_V2, initGLH());
    }

    public Map<String, Object> initGLH() {
        HashMap<String, Object> map = new HashMap<>();

        map.put("港股", "格隆汇-快讯");
        map.put("A股", "格隆汇-快讯");
        map.put("美股", "格隆汇-快讯");
        map.put("商品外汇", "格隆汇-快讯");
        map.put("楼市", "格隆汇-快讯");
        map.put("基⾦", "格隆汇-快讯");
        map.put("债券", "格隆汇-快讯");

        map.put("港股公告摘要", "格隆汇-要闻");
        map.put("⼤⾏评级", "格隆汇-要闻");
        map.put("业绩直击", "格隆汇-要闻");
        map.put("港股异动", "格隆汇-要闻");
        map.put("公司信息", "格隆汇-要闻");
        map.put("市场综述", "格隆汇-要闻");
        map.put("新股速递", "格隆汇-要闻");
        map.put("A股公告摘要", "格隆汇-要闻");
        map.put("美股异动", "格隆汇-要闻");

        return map;
    }


    @Override
    public String getValue(String namespace, String key) {
        Map<String, Object> map = store.get(namespace);
        if (map == null) {
            throw new RuntimeException("namespace [" + namespace + "] not found in local store");
        }
        Object value = map.getOrDefault(key, null);
        if (value == null) {
            return null;
        }
        return value.toString();
    }
}
