package work.xuye.source.processor;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.messaging.Message;
import work.xuye.common.dto.HttpRequestParams;
import work.xuye.common.dto.HttpRes;
import work.xuye.source.handler.SourceHandler;

import java.util.function.Function;

/**
 * @author xuye
 * @since 2023/1/15 19:00
 **/
@Slf4j
@Configuration
@RequiredArgsConstructor
public class MessageConsumer {

    private final SourceHandler sourceHandler;

    @Bean
    public Function<Message<HttpRequestParams>, Message<HttpRes>> source() {
        return sourceHandler::handle;
    }


}
